POJ 1511 Invitation Cards 【最短路,spfa算法,Dijkstra算法堆优化】

Invitation Cards

Time Limit: 8000MS   Memory Limit: 262144K
Total Submissions: 25219   Accepted: 8346

Description

In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards with all the necessary information
and with the programme. A lot of students were hired to distribute these invitations among the people. Each student volunteer has assigned exactly one bus stop and he or she stays there the whole day and gives invitation to people travelling by bus. A special
course was taken where students learned how to influence people and what is the difference between influencing and robbery.

The transport system is very special: all lines are unidirectional and connect exactly two stops. Buses leave the originating stop with passangers each half an hour. After reaching the destination stop they return empty to the originating stop, where they wait
until the next full half an hour, e.g. X:00 or X:30, where ‘X‘ denotes the hour. The fee for transport between two stops is given by special tables and is payable on the spot. The lines are planned in such a way, that each round trip (i.e. a journey starting
and finishing at the same stop) passes through a Central Checkpoint Stop (CCS) where each passenger has to pass a thorough check including body scan.

All the ACM student members leave the CCS each morning. Each volunteer is to move to one predetermined stop to invite passengers. There are as many volunteers as stops. At the end of the day, all students travel back to CCS. You are to write a computer program
that helps ACM to minimize the amount of money to pay every day for the transport of their employees.

Input

The input consists of N cases. The first line of the input contains only positive integer N. Then follow the cases. Each case begins with a line containing exactly two integers P and Q, 1 <= P,Q <= 1000000. P is the number of stops including CCS and Q the number
of bus lines. Then there are Q lines, each describing one bus line. Each of the lines contains exactly three numbers - the originating stop, the destination stop and the price. The CCS is designated by number 1. Prices are positive integers the sum of which
is smaller than 1000000000. You can also assume it is always possible to get from any stop to any other stop.

Output

For each case, print one line containing the minimum amount of money to be paid each day by ACM for the travel costs of its volunteers.

Sample Input

2
2 2
1 2 13
2 1 33
4 6
1 2 10
2 1 60
1 3 20
3 4 10
2 4 5
4 1 50

Sample Output

46
210

Source

Central Europe 1998

原题链接:http://poj.org/problem?id=1511

参考博客:http://blog.csdn.net/wuyanyi/article/details/7286014

题意:

给定节点数n,和边数m,边是单向边.

问从1节点出发到2,3,...n 这些节点路程和从从这些节点回来到节点1的路程和最小值。

思路:

很显然的最短路,先以1为起点进行一次最短路,然后再将边反向一下再以1为起点进行一下最短路。

这题的意义在于数据,一般的dijstra的O(N^2)显然没法过。

dijstra+heap,其实heap直接用priority_queue实现即可

spfa算法AC代码;

#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
using namespace std;
const int maxn=1000000+10;
typedef long long LL ;
const LL INF = 0x3f3f3f3f3f3f3f3f;
int n,m;
struct node
{
    int to,next,w;
} edge[maxn];
int head[maxn];
int a[maxn][3];
LL dis[maxn];
bool vis[maxn];
int cnt;
void addEdge(int u,int v,int w)
{
    edge[cnt].to=v;
    edge[cnt].w=w;
    edge[cnt].next=head[u];
    head[u]=cnt++;
}
void Init()
{
    cnt=0;
    memset(head,-1,sizeof(head));
    memset(vis,false,sizeof(vis));
    for(int i=0; i<=n; i++)
        dis[i]=INF;
}
LL spfa()
{
    queue<int>q;
    q.push(1);
    vis[1]=true;
    dis[1]=0;
    while(!q.empty())
    {
        int p = q.front();
        q.pop();
        vis[p] = false ;
        //注意spfa的vis和dijstra的不同点,
        //前者是判断是否在queue里而已
        //后者是判断是否已经是最优的点。
        for (int i=head[p]; i!=-1; i=edge[i].next)
        {
            int to = edge[i].to;
            int w = edge[i].w;
            if(dis[to]>dis[p]+w)
            {
                dis[to]=dis[p]+w;
                if(!vis[to])
                {
                    q.push(to);
                    vis[to]=true;
                }
            }
        }
    }
    LL ans = 0;
    for (int i=1; i<=n; i++)
    {
        ans+=dis[i];
    }
    return ans;
}
int main()
{
    int T;
    //freopen("data/1511.txt","r",stdin);
    cin>>T;
    int x,y,z;
    while(T--)
    {
        cin>>n>>m;
        Init();
        for(int i=0; i<m; i++)
        {
            scanf("%d%d%d",&a[i][0],&a[i][1],&a[i][2]);
            addEdge(a[i][0],a[i][1],a[i][2]);
        }
        LL ans = spfa();
        Init();
        for(int i=0; i<m; i++)
        {
            addEdge(a[i][1],a[i][0],a[i][2]);
        }
        ans += spfa();
        cout<<ans<<endl;
    }
    return 0;
}

Dijkstra算法AC代码:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
#include <vector>
using namespace std;
const int maxn=1000000+10;
typedef long long LL ;
const LL INF = 0x3f3f3f3f3f3f3f3f;
int n,m;
struct node
{
    int to,next,w;
} edge[maxn];
int head[maxn];
int a[maxn][3];
LL dis[maxn];
bool vis[maxn];
int cnt;
void addEdge(int u,int v,int w)
{
    edge[cnt].to=v;
    edge[cnt].w=w;
    edge[cnt].next=head[u];
    head[u]=cnt++;
}
void Init()
{
    cnt=0;
    memset(head,-1,sizeof(head));
    memset(vis,false,sizeof(vis));
    for(int i=0; i<=n; i++)
        dis[i]=INF;
}
struct cmp
{
    //注意priority_queue的cmp写的和sort里面的cmp的区别,
    //前者是struct,后者是函数,
    //而且比较大小的关系刚好是相反的。
    bool operator() (const int a,const int b)
    {
        return dis[a]>dis[b];
    }
};
LL Dijkstra()
{
    priority_queue<int,vector<int>,cmp>q;
    dis[1] = 0;
    q.push(1);
    while(!q.empty())
    {
        int p = q.top();
        q.pop();
        vis[p] = true;
        for(int i=head[p]; i!=-1; i=edge[i].next)
        {
            int to=edge[i].to;
            int w=edge[i].w;
            //如果是可松弛点即加入优先队列,dis值越小越优先。
            if(!vis[to]&&dis[to]>dis[p]+w)
            {
                dis[to]=dis[p]+w;
                q.push(to);
            }
        }
    }
    LL ans = 0;
    for(int i=1; i<=n; i++)
        ans+=dis[i];
    return ans;
}
int main()
{
    int T;
    //freopen("data/1511.txt","r",stdin);
    cin>>T;
    int x,y,z;
    while(T--)
    {
        cin>>n>>m;
        Init();
        for(int i=0; i<m; i++)
        {
            scanf("%d%d%d",&a[i][0],&a[i][1],&a[i][2]);
            addEdge(a[i][0],a[i][1],a[i][2]);
        }
        LL ans = Dijkstra();
        Init();
        for(int i=0; i<m; i++)
        {
            addEdge(a[i][1],a[i][0],a[i][2]);
        }
        ans += Dijkstra();
        cout<<ans<<endl;
    }
    return 0;
}
时间: 2024-12-21 05:46:15

POJ 1511 Invitation Cards 【最短路,spfa算法,Dijkstra算法堆优化】的相关文章

POJ 1511 Invitation Cards (最短路)

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 19215   Accepted: 6311 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wan

POJ 1511 Invitation Cards 邻接表 spfa算法

原题: http://poj.org/problem?id=1511 题目大意: 单向图,需要从点1到每个点去一次,去了马上回来,再去下一个点,求往返路径和. 如果只有100个点,跑一遍floyd就可以了,这里有10w个点,不行. 朴素的dijkstra是N^2的复杂度,这里要超时. 所以这里我们用spfa这种接近2N的算法. 由于二维数组空间不够,所以只能用vector或者邻接表,因为vector的适合经常修改,本身是链表结构,每次插入数据都会消耗时间来申请内存并和前面建立联系,虽然可以支持下

POJ 1511 Invitation Cards

题目来源:http://poj.org/problem?id=1511 题目很长,花了不少时间才理解题意,目的就是为了求出来回两次最小路径(即为本题的差旅费)之和, 第一次从CCS(1)出发到各个点路径最小,SPFA算法没得说,回来时终点是确定的都是CCS(1),相当于把路 径反过来,即把有向图去反方向,又是从1出发到各个点路径最小,再用一个SPFA.注意ans要用long long 不然也WA,这个地方WA了好几次,虽然更改后AC了,但还是不明白,题目明明写了smaller than 1000

[2016-04-05][POJ][1511][Invitation Cards]

时间:2016-04-05 12:57:22 星期二 题目编号:[2016-04-05][POJ][1511][Invitation Cards] 题目大意:给定一个有向图,从点1出发,分别到各个站点后,又回到点1,问最少需要多少车费, 分析: 从1跑一次最短路,然后矩阵转置,再跑一次最短路,两次求和 这里不能用邻接矩阵保存,所以改成邻接表,然后矩阵转置的操作变成重新加一次边 遇到的问题:用vector存图超时,改用数组实现 #include <queue> #include <algo

POJ1511 Invitation Cards —— 最短路spfa

题目链接:http://poj.org/problem?id=1511 Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 29286   Accepted: 9788 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidine

HDU 1535 &amp;&amp; POJ 1511 Invitation Cards (SPFA 模板 + 反向建图)

Invitation Cards HDU: Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) POJ: Time Limit: 8000 MS     Memory Limit: 262144 K       Problem Description In the age of television, not many people attend theater performa

poj 1511 Invitation Cards (spfa+邻接表)

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 19527   Accepted: 6375 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wan

poj 1511 Invitation Cards (最短路)

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 33435   Accepted: 11104 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wa

(简单) POJ 1511 Invitation Cards,SPFA。

Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards with all